#!/usr/bin/python

from math import floor

def gradient(color1,color2,colors):
	"gradient(tuple,tuple,int)->list of tuples - make a gradient palette"
	iters=colors*1.0

	fr=(color2[0]-color1[0])/iters
	fg=(color2[1]-color1[1])/iters
	fb=(color2[2]-color1[2])/iters

	r=color1[0]
	g=color1[1]
	b=color1[2]
	iters=int(iters)

	pal=list()
	for i in range(iters):
		pal.append((int(r),int(g),int(b)))
		r+=fr
		g+=fg
		b+=fb
	
	pal[iters-1]=(color2[0],color2[1],color2[2])
	return pal

colors=int(raw_input())
points=int(raw_input())

cls=list()
for i in range(points):
	rgb=raw_input().split()
	cls.append((int(rgb[0]),int(rgb[1]),int(rgb[2])))

outpal=list()
block=floor(colors/(points-1)*1.0)
for i in range(points-1):
	pal=gradient(cls[i],cls[i+1],block)
	outpal+=pal

for i in outpal:
	print "%3d %3d %3d" % (i[0],i[1],i[2]);
