#include <stdio.h>
#include <SDL/SDL.h>

#include "sdlpal.h"

SDL_Color *readpalette(char *palfile,int *l) {
	FILE *soub=fopen(palfile,"r");
	if (soub==NULL) {
		fprintf(stderr,"plasma: %s: Nu such file or directory\n",palfile);
		exit(1);
	}
	
	long int lines;
	int c;
	int r,g,b;
	SDL_Color *pal;
	lines=0;
	while ((c=fgetc(soub))!=EOF) {
 		if (c=='\n') {
			lines++;
		}
	}
	pal=(SDL_Color *)malloc(sizeof(SDL_Color)*lines);
	soub=freopen(palfile,"r",soub);
	for (c=0;c<lines;c++) {
		fscanf(soub,"%d %d %d \n",&r,&g,&b);
		pal[c].r=r;
		pal[c].g=g;
		pal[c].b=b;
	}
	*l=lines;
	return pal;
}

int convcolor(SDL_Color c) {
	return c.r*65536+c.g*256+c.b;
}
